; ##############################################################################
; ##############################################################################
; ##############################################################################
; die ersten 100 Bytes der SRAM-Daten speichern, die die sich gendert haben	
EEPROM_KONFIGURATION_SPEICHERN:
	; ZEIGER		
	clr ZL
	clr ZH
	; SRAM-START	
	ldi XL, LOW (SRAM_START)
	ldi XH, HIGH(SRAM_START)
	; Schleife		
	ldi temp,100
EEPROM_KONFIGURATION_SPEICHERN_s:	
	; SRAM-Wert laden	
	LD temp1,X+
	; EEPROM-Wert laden	
	rcall EEPROM_READ_TEMP2
	; vergleich			
	cp temp1,temp2
	brne EEPROM_KONFIGURATION_SPEICHERN_SAVE
EEPROM_KONFIGURATION_SPEICHERN_NO_SAVE:
	; ZEIGER +1 		
	adiw ZL,1
	rjmp EEPROM_KONFIGURATION_SPEICHERN_w
EEPROM_KONFIGURATION_SPEICHERN_SAVE:
	rcall EEPROM_WRITE_PLUS_TEMP1
EEPROM_KONFIGURATION_SPEICHERN_w:
	dec temp
	brne EEPROM_KONFIGURATION_SPEICHERN_s

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; die ersten 100 Bytes des SRAM(Daten) laden									
EEPROM_KONFIGURATION_LADEN:
	; ZEIGER		
	clr ZL
	clr ZH
	; SRAM-START	
	ldi XL, LOW (SRAM_START)
	ldi XH, HIGH(SRAM_START)
	; Schleife		
	ldi temp,100
EEPROM_KONFIGURATION_LADEN_s:
	rcall EEPROM_READ_PLUS_TEMP1
	ST X+,temp1
	dec temp
	brne EEPROM_KONFIGURATION_LADEN_s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; INPUT:	ZL Adresse (low)													
;			ZH Adresse (High)													
;																				
; OUTPUT: 	TEMP1 (DATEN)														
;																				
EEPROM_READ_PLUS_TEMP1:
	sbic EECR,EEWE 		; Wait for completion of previous write
	rjmp EEPROM_READ_PLUS_TEMP1
	out  EEARH, ZH		; ADRESSE setzen						
	out  EEARL, ZL
	sbi  EECR,EERE		; Start eeprom read by writing EERE		
	in 	 temp1,EEDR		; Read data from data register			
	adiw ZL,1			; ADRESSE +1 							
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; INPUT:	ZL Adresse (low)													
;			ZH Adresse (High)													
;																				
; OUTPUT: 	TEMP2 (DATEN)														
;																				
EEPROM_READ_TEMP2:
	sbic EECR,EEWE 		; Wait for completion of previous write
	rjmp EEPROM_READ_TEMP2
	out  EEARH, ZH		; ADRESSE setzen						
	out  EEARL, ZL
	sbi  EECR,EERE		; Start eeprom read by writing EERE		
	in 	 temp2,EEDR		; Read data from data register			
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; Ein Byte im EEPROM ablegen und Z-Zeiger + 1									
;																				
; INPUT:	ZL Adresse (low)													
;			ZH Adresse (High)													
;																				
; 		 	TEMP1  DATEN														
;																				
EEPROM_WRITE_PLUS_TEMP1:
	cbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB an	
	sbic EECR,EEWE		; Wait for completion of previous write
	rjmp EEPROM_WRITE_PLUS_TEMP1
	WDR
	out  EEARH,ZH		; ADRESSE setzen						
	out  EEARL,ZL
	out  EEDR, temp1	; Write data  to data register			
	sbi  EECR, EEMWE	; Write logical one to EEMWE			
	sbi  EECR, EEWE		; Start eeprom write by setting EEWE	
	adiw ZL,1			; ADRESSE +1 							
	sbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB aus	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

