; ##############################################################################
; ##############################################################################
; ##############################################################################
; Diagramm X=32Punkte pro Teilung												
; Diagramm Y=20Punkte pro Teilung												
;																				
; Ausgang Logarithmierer AD8307: 												
;	max 2.400mV																	
;	25mv/dB																		
;																				
; ADC bei Uref 2.500mV:															
;	10 Digit/db																	
;																				
DIAGRAMM_SCAN:
	; DIAGRAMM-Initialisierung			
	STS(adr_DIAGRAMM_OPTION_LAUS_EIN),EINS		; kleiner Punkt unter der X-Achse	
	STS(adr_DIAGRAMM_OPTION_CLEAR_EIN),EINS		; vorhergehende Kurve lschen		
	STS(adr_DIAGRAMM_OPTION_KURVE_A_EIN),EINS	; Kurve-A							
	STS(adr_DIAGRAMM_OPTION_KURVE_B_EIN),NULL	; Kurve-B							
	STS(adr_DIAGRAMM_OPTION_KURVE_C_EIN),NULL	; Kurve-C							
	STS(adr_DIAGRAMM_OPTION_KURVE_D_EIN),NULL	; Kurve-D							
	; CHECK START und STOPP Frequenz	
	rcall FUNKTION_DIAGRAMM_CHECK
	; BERECHNUNG CENTER-FREQUENZ		
 	LDS temp1,(adr_FREQUENZ_STOPP_BYTE0)
 	LDS temp2,(adr_FREQUENZ_STOPP_BYTE1)
 	LDS temp3,(adr_FREQUENZ_STOPP_BYTE2)
 	LDS temp4,(adr_FREQUENZ_STOPP_BYTE3)
 	LDS temp5,(adr_FREQUENZ_START_BYTE0)
 	LDS temp6,(adr_FREQUENZ_START_BYTE1)
 	LDS temp7,(adr_FREQUENZ_START_BYTE2)
 	LDS temp8,(adr_FREQUENZ_START_BYTE3)
	rcall FUNKTION_TEMP1_4_PLUS_TEMP5_8		; +		
	rcall FUNKTION_TEMP1_4_DURCH_2			; :2	
	STS(adr_FREQUENZ_CENTER_BYTE0),temp1
	STS(adr_FREQUENZ_CENTER_BYTE1),temp2
	STS(adr_FREQUENZ_CENTER_BYTE2),temp3
	STS(adr_FREQUENZ_CENTER_BYTE3),temp4
	; BERECHNUNG SPAN					
	rcall FUNKTION_FREQUENZ_STOPP_MINUS_FREQUENZ_START_TEMP1_4		; STOPP-START
	STS(adr_FREQUENZ_SPAN_BYTE0),temp1
	STS(adr_FREQUENZ_SPAN_BYTE1),temp2
	STS(adr_FREQUENZ_SPAN_BYTE2),temp3
	STS(adr_FREQUENZ_SPAN_BYTE3),temp4
	; BERECHNUNG STEP					
	rcall FUNKTION_FREQUENZ_STOPP_MINUS_FREQUENZ_START_TEMP1_4		; STOPP-START
	rcall FUNKTION_TEMP1_4_DURCH_320		; :320	
	STS(adr_FREQUENZ_STEP_BYTE0),temp1
	STS(adr_FREQUENZ_STEP_BYTE1),temp2
	STS(adr_FREQUENZ_STEP_BYTE2),temp3
	STS(adr_FREQUENZ_STEP_BYTE3),temp4
	; RASTER							
	rcall DIAGRAMM_RASTER_ZEICHEN			; Raster		
	; Text (oben)						
	rcall GRAFIC_ZEILE_1
	rcall GRAFIC_FARBE_GELB
	rcall ANZEIGE_DIAGRAMM_Y_DB_PRO_TEILUNG_KURZ

	rcall GRAFIC_FARBE_GRAU
	rcall ANZEIGE_TEXT_TS
	rcall ANZEIGE_TURBO_SCHWELLE_KURZ

	rcall GRAFIC_FARBE_GELB
	ldi temp1,26							; Positionieren	
	ldi temp2,1
	rcall GRAFIC_KURSOR_POSITION_X_Y_TEMP1_2
	rcall ANZEIGE_DIAGRAMM_X_HZ_PRO_TEILUNG_KURZ
	; Text (unten)						
	rcall GRAFIC_ZEILE_15
	rcall GRAFIC_FARBE_GRAU
	rcall ANZEIGE_FREQUENZ_START_KURZ
	rcall GRAFIC_SPACE3
	rcall GRAFIC_FARBE_GELB
	rcall ANZEIGE_FREQUENZ_CENTER_KURZ
	ldi temp1,30							; Positionieren	
	ldi temp2,15
	rcall GRAFIC_KURSOR_POSITION_X_Y_TEMP1_2
	rcall GRAFIC_FARBE_GRAU
	rcall ANZEIGE_FREQUENZ_STOPP_KURZ
	; EEPROM-KONFIGURATION SPEICHERN	
	rcall EEPROM_KONFIGURATION_SPEICHERN
;-------------------------------------------------------------------------------
DIAGRAMM_SCAN_s:
	; Tasten abfragen	
	rcall TASTE_GEDRUECKT_CARRY
	brcc DIAGRAMM_SCAN_w
	ret
DIAGRAMM_SCAN_w:
;-------------------------------------------------------------------------------
	; FREQUENZ einstellen			
	rcall DIAGRAMM_FREQUENZ_BERECHNEN_EINSTELLEN
	; MESSEN (log)			
	rcall DIAGRAMM_MESSEN_TURBO
	; ADC laden				
 	LDS temp1,(adr_ADC_0_L)
 	LDS temp2,(adr_ADC_0_H)
	clr temp3
	clr temp4
	; OFFSET				
	LDS temp5,(adr_DIAGRAMM_Y_OFFSET_BYTE0)
	LDS temp6,(adr_DIAGRAMM_Y_OFFSET_BYTE1)
	LDS temp7,(adr_DIAGRAMM_Y_OFFSET_BYTE2)
	LDS temp8,(adr_DIAGRAMM_Y_OFFSET_BYTE3)
	rcall FUNKTION_TEMP1_4_MINUS_TEMP5_8
	rcall FUNKTION_TEMP1_4_NEGATIV_BEGRENZEN
	; SKALE			
 	LDS temp5,(adr_DIAGRAMM_Y_SKALA)
	ROR temp5	; durch 2 
	clr temp6
	clr temp7
	clr temp8
	rcall DIVISION_32_32
	rcall FUNKTION_TEMP1_4_BEGRENZEN_255
	STS(adr_DIAGRAMM_Y_WERT_A),temp1			; speichern
	subi temp1,-20
	STS(adr_DIAGRAMM_Y_WERT_B),temp1			; speichern
	subi temp1,-20
	STS(adr_DIAGRAMM_Y_WERT_C),temp1			; speichern
	subi temp1,-20
	STS(adr_DIAGRAMM_Y_WERT_D),temp1			; speichern
;-------------------------------------------------------------------------------
	; zeichnen			
	rcall DIAGRAMM_ZEICHNEN_KURVEN					; KURVEN	

rjmp DIAGRAMM_SCAN_s
; ##############################################################################
; ##############################################################################
; ##############################################################################
; DDS-Generatoren arbeiten beim Umschalten auf eine andere Frequenz manchmal		
; etwas unsauber.																	
; Bei einer sprunghaften nderung des Messwertes, kurze Pause, dann nochmal messen	
DIAGRAMM_MESSEN_TURBO:
	; MESSEN			
	rcall MESSEN_0_TEMP1_2_SRAM
	; laden				
  	LDS temp1,(adr_ADC_0_L)
 	LDS temp2,(adr_ADC_0_H)
 	LDS temp3,(adr_ADC_0_OLD_L)
 	LDS temp4,(adr_ADC_0_OLD_H)
	; ADC-OLD speichern		
	STS(adr_ADC_0_OLD_L),temp1
	STS(adr_ADC_0_OLD_H),temp2
	; DIFFERENZ bilden	
	sub temp1,temp3
	sbc temp2,temp4
	; ist positiv ?		
	tst temp2
	brpl DIAGRAMM_MESSEN_TURBO_P
	; invertieren		
	com temp1
	com temp2
	add temp1,EINS
	adc temp2,NULL
DIAGRAMM_MESSEN_TURBO_P:
	; Schwelle			
	tst temp2
	brne DIAGRAMM_MESSEN_NO_TURBO
	; Schwelle			
	LDS temp,(adr_DIAGRAMM_TURBO_SCHWELLE)
	cp temp1,temp
	brsh DIAGRAMM_MESSEN_NO_TURBO
	ret
DIAGRAMM_MESSEN_NO_TURBO:
	; PAUSE				
	rcall wait_20ms
	rcall wait_20ms
	rcall wait_20ms
	; MESSEN			
	rcall MESSEN_0_TEMP1_2_SRAM
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DIAGRAMM_FREQUENZ_BERECHNEN_EINSTELLEN:
	; SPAN laden		
	LDS temp1,(adr_FREQUENZ_SPAN_BYTE0)
	LDS temp2,(adr_FREQUENZ_SPAN_BYTE1)
	LDS temp3,(adr_FREQUENZ_SPAN_BYTE2)
	LDS temp4,(adr_FREQUENZ_SPAN_BYTE3)
	; SPAN laden		
	LDS temp5,(adr_DIAGRAMM_SPALTE_L)
	LDS temp6,(adr_DIAGRAMM_SPALTE_H)
	clr temp7
	clr temp8
	rcall MULTIPLIKATION_32_32
	rcall FUNKTION_TEMP1_4_DURCH_320

 	LDS temp5,(adr_FREQUENZ_START_BYTE0)
 	LDS temp6,(adr_FREQUENZ_START_BYTE1)
 	LDS temp7,(adr_FREQUENZ_START_BYTE2)
 	LDS temp8,(adr_FREQUENZ_START_BYTE3)

	rcall FUNKTION_TEMP1_4_PLUS_TEMP5_8

	rcall FUNKTION_TEMP1_4_NACH_FREQUENZ

	rcall SPI_DDS_FREQUENZ_EINSTELLEN
	; kurze Pause		
	rcall wait_1ms
;-------------------------------------------------------------------------------
	; kurze Pause bei Diagramm-ANFANG		
	LDS temp1,(adr_DIAGRAMM_SPALTE_L)
	LDS temp2,(adr_DIAGRAMM_SPALTE_H)
	tst temp1
	brne DIAGRAMM_FREQUENZ_BERECHNEN_EINSTELLEN_RUN
	tst temp2
	brne DIAGRAMM_FREQUENZ_BERECHNEN_EINSTELLEN_RUN
	rcall wait_1s
DIAGRAMM_FREQUENZ_BERECHNEN_EINSTELLEN_RUN:


ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DIAGRAMM_ZF_1:
	ldi temp1,BYTE1(2000000-160)
	ldi temp2,BYTE2(2000000-160)
	ldi temp3,BYTE3(2000000-160)
	ldi temp4,BYTE4(2000000-160)
 	STS(adr_FREQUENZ_START_BYTE0),temp1
 	STS(adr_FREQUENZ_START_BYTE1),temp2
 	STS(adr_FREQUENZ_START_BYTE2),temp3
 	STS(adr_FREQUENZ_START_BYTE3),temp4
	ldi temp1,BYTE1(2000000+160)
	ldi temp2,BYTE2(2000000+160)
	ldi temp3,BYTE3(2000000+160)
	ldi temp4,BYTE4(2000000+160)
 	STS(adr_FREQUENZ_STOPP_BYTE0),temp1
 	STS(adr_FREQUENZ_STOPP_BYTE1),temp2
 	STS(adr_FREQUENZ_STOPP_BYTE2),temp3
 	STS(adr_FREQUENZ_STOPP_BYTE3),temp4
	rcall DIAGRAMM_SCAN
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DIAGRAMM_ZF_2:
	ldi temp1,BYTE1(2000000-320)
	ldi temp2,BYTE2(2000000-320)
	ldi temp3,BYTE3(2000000-320)
	ldi temp4,BYTE4(2000000-320)
 	STS(adr_FREQUENZ_START_BYTE0),temp1
 	STS(adr_FREQUENZ_START_BYTE1),temp2
 	STS(adr_FREQUENZ_START_BYTE2),temp3
 	STS(adr_FREQUENZ_START_BYTE3),temp4
	ldi temp1,BYTE1(2000000+320)
	ldi temp2,BYTE2(2000000+320)
	ldi temp3,BYTE3(2000000+320)
	ldi temp4,BYTE4(2000000+320)
 	STS(adr_FREQUENZ_STOPP_BYTE0),temp1
 	STS(adr_FREQUENZ_STOPP_BYTE1),temp2
 	STS(adr_FREQUENZ_STOPP_BYTE2),temp3
 	STS(adr_FREQUENZ_STOPP_BYTE3),temp4
	rcall DIAGRAMM_SCAN
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DIAGRAMM_ZF_3:
	ldi temp1,BYTE1(2000000-640)
	ldi temp2,BYTE2(2000000-640)
	ldi temp3,BYTE3(2000000-640)
	ldi temp4,BYTE4(2000000-640)
 	STS(adr_FREQUENZ_START_BYTE0),temp1
 	STS(adr_FREQUENZ_START_BYTE1),temp2
 	STS(adr_FREQUENZ_START_BYTE2),temp3
 	STS(adr_FREQUENZ_START_BYTE3),temp4
	ldi temp1,BYTE1(2000000+640)
	ldi temp2,BYTE2(2000000+640)
	ldi temp3,BYTE3(2000000+640)
	ldi temp4,BYTE4(2000000+640)
 	STS(adr_FREQUENZ_STOPP_BYTE0),temp1
 	STS(adr_FREQUENZ_STOPP_BYTE1),temp2
 	STS(adr_FREQUENZ_STOPP_BYTE2),temp3
 	STS(adr_FREQUENZ_STOPP_BYTE3),temp4
	rcall DIAGRAMM_SCAN
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DIAGRAMM_ZEICHNEN_KURVEN:
	; LAUS zeichnen		
	LDS temp,(adr_DIAGRAMM_OPTION_LAUS_EIN)
	tst temp
	breq DIAGRAMM_ZEICHNEN_LAUS_NO
	rcall DIAGRAMM_LAUS_ZEICHNEN
DIAGRAMM_ZEICHNEN_LAUS_NO:
	; ALTE KURVE CLEAR	
	LDS temp,(adr_DIAGRAMM_OPTION_CLEAR_EIN)
	tst temp
	breq DIAGRAMM_ZEICHNEN_CLEAR_NO
	rcall DIAGRAMM_AKTUELLE_SPALTE_CLEAR
DIAGRAMM_ZEICHNEN_CLEAR_NO:
	; KURVE A			
	LDS temp,(adr_DIAGRAMM_OPTION_KURVE_A_EIN)	
	tst temp
	breq DIAGRAMM_ZEICHNEN_KURVEN_A_NO
	rcall DIAGRAMM_ZEICHNEN_KURVE_A
DIAGRAMM_ZEICHNEN_KURVEN_A_NO:
	; KURVE B 			
	LDS temp,(adr_DIAGRAMM_OPTION_KURVE_B_EIN)	
	tst temp
	breq DIAGRAMM_ZEICHNEN_KURVEN_B_NO
	rcall DIAGRAMM_ZEICHNEN_KURVE_B
DIAGRAMM_ZEICHNEN_KURVEN_B_NO:
	; KURVE C 			
	LDS temp,(adr_DIAGRAMM_OPTION_KURVE_C_EIN)	
	tst temp
	breq DIAGRAMM_ZEICHNEN_KURVEN_C_NO
	rcall DIAGRAMM_ZEICHNEN_KURVE_C
DIAGRAMM_ZEICHNEN_KURVEN_C_NO:
	; KURVE D			
	LDS temp,(adr_DIAGRAMM_OPTION_KURVE_D_EIN)	
	tst temp
	breq DIAGRAMM_ZEICHNEN_KURVEN_D_NO
	rcall DIAGRAMM_ZEICHNEN_KURVE_D
DIAGRAMM_ZEICHNEN_KURVEN_D_NO:
	; PAKET_SENDEN		
	rcall PAKET_SENDEN
	; Spalte + 1		
	rcall DIAGRAMM_SPALTE_PLUS_EINS
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DIAGRAMM_ZEICHNEN_KURVE_A:
	rcall GRAFIC_PUNKTGROESSE_1			; Punktgre	
	ldi temp1,(FARBE_KURVE_A)			; Farbe			
	rcall GRAFIC_FARBE_TEMP1
	; X-SPALTE laden				
	LDS temp1,(adr_DIAGRAMM_SPALTE_L)	; X1L
	LDS temp2,(adr_DIAGRAMM_SPALTE_H)	; X1H
	; erster Datenpunkt	?			
	tst temp1
	brne DIAGRAMM_ZEICHNEN_KURVE_A_LINIE
	tst temp2
	brne DIAGRAMM_ZEICHNEN_KURVE_A_LINIE
	; ja, erster Datenpunkt			
	LDS temp,(adr_DIAGRAMM_Y_WERT_A)
	STS (adr_DIAGRAMM_Y_WERT_A_OLD),temp
	rjmp DIAGRAMM_ZEICHNEN_KURVE_A_LINIE_w
DIAGRAMM_ZEICHNEN_KURVE_A_LINIE:
	; X-Spalte Minus 1	(fr LINIE)			
	sub temp1,EINS						; X1L
	sbc temp2,NULL						; X1H
DIAGRAMM_ZEICHNEN_KURVE_A_LINIE_W:
	LDS temp,(adr_DIAGRAMM_Y_WERT_A_OLD)
	rcall DIAGRAMM_Y_WERT_AUFBEREITEN_TEMP	; Y-wert aufbereiten (0...200)	
	mov temp3,temp						; Y1L
	clr temp4							; Y1H
	LDS temp5,(adr_DIAGRAMM_SPALTE_L)	; X2L
	LDS temp6,(adr_DIAGRAMM_SPALTE_H)	; X2H
	LDS temp,(adr_DIAGRAMM_Y_WERT_A)	
	rcall DIAGRAMM_Y_WERT_AUFBEREITEN_TEMP	; Y-wert aufbereiten (0...200)	
	mov temp7,temp						; Y2L
	clr temp8							; Y2H
	; Linie zeichnen				
	rcall GRAFIC_LINIE_TEMP1_8
	; OLD speichern	(fr nchste Linie)
	LDS temp,(adr_DIAGRAMM_Y_WERT_A)	
	STS (adr_DIAGRAMM_Y_WERT_A_OLD),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DIAGRAMM_ZEICHNEN_KURVE_B:
	rcall GRAFIC_PUNKTGROESSE_1			; Punktgre	
	ldi temp1,(FARBE_KURVE_B)			; Farbe			
	rcall GRAFIC_FARBE_TEMP1
	; X-SPALTE laden				
	LDS temp1,(adr_DIAGRAMM_SPALTE_L)	; X1L
	LDS temp2,(adr_DIAGRAMM_SPALTE_H)	; X1H
	; erster Datenpunkt	?			
	tst temp1
	brne DIAGRAMM_ZEICHNEN_KURVE_B_LINIE
	tst temp2
	brne DIAGRAMM_ZEICHNEN_KURVE_B_LINIE
	; ja, erster Datenpunkt			
	LDS temp,(adr_DIAGRAMM_Y_WERT_B)
	STS (adr_DIAGRAMM_Y_WERT_B_OLD),temp
	rjmp DIAGRAMM_ZEICHNEN_KURVE_B_LINIE_w
DIAGRAMM_ZEICHNEN_KURVE_B_LINIE:
	; X-Spalte Minus 1	(fr LINIE)			
	sub temp1,EINS						; X1L
	sbc temp2,NULL						; X1H
DIAGRAMM_ZEICHNEN_KURVE_B_LINIE_W:
	LDS temp,(adr_DIAGRAMM_Y_WERT_B_OLD)
	rcall DIAGRAMM_Y_WERT_AUFBEREITEN_TEMP	; Y-wert aufbereiten (0...200)	
	mov temp3,temp						; Y1L
	clr temp4							; Y1H
	LDS temp5,(adr_DIAGRAMM_SPALTE_L)	; X2L
	LDS temp6,(adr_DIAGRAMM_SPALTE_H)	; X2H
	LDS temp,(adr_DIAGRAMM_Y_WERT_B)	
	rcall DIAGRAMM_Y_WERT_AUFBEREITEN_TEMP	; Y-wert aufbereiten (0...200)	
	mov temp7,temp						; Y2L
	clr temp8							; Y2H
	; Linie zeichnen				
	rcall GRAFIC_LINIE_TEMP1_8
	; OLD speichern	(fr nchste Linie)
	LDS temp,(adr_DIAGRAMM_Y_WERT_B)	
	STS (adr_DIAGRAMM_Y_WERT_B_OLD),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DIAGRAMM_ZEICHNEN_KURVE_C:
	rcall GRAFIC_PUNKTGROESSE_1			; Punktgre	
	ldi temp1,(FARBE_KURVE_C)			; Farbe			
	rcall GRAFIC_FARBE_TEMP1
	; X-SPALTE laden				
	LDS temp1,(adr_DIAGRAMM_SPALTE_L)	; X1L
	LDS temp2,(adr_DIAGRAMM_SPALTE_H)	; X1H
	; erster Datenpunkt	?			
	tst temp1
	brne DIAGRAMM_ZEICHNEN_KURVE_C_LINIE
	tst temp2
	brne DIAGRAMM_ZEICHNEN_KURVE_C_LINIE
	; ja, erster Datenpunkt			
	LDS temp,(adr_DIAGRAMM_Y_WERT_C)
	STS (adr_DIAGRAMM_Y_WERT_C_OLD),temp
	rjmp DIAGRAMM_ZEICHNEN_KURVE_C_LINIE_w
DIAGRAMM_ZEICHNEN_KURVE_C_LINIE:
	; X-Spalte Minus 1	(fr LINIE)			
	sub temp1,EINS						; X1L
	sbc temp2,NULL						; X1H
DIAGRAMM_ZEICHNEN_KURVE_C_LINIE_W:
	LDS temp,(adr_DIAGRAMM_Y_WERT_C_OLD)
	rcall DIAGRAMM_Y_WERT_AUFBEREITEN_TEMP	; Y-wert aufbereiten (0...200)	
	mov temp3,temp						; Y1L
	clr temp4							; Y1H
	LDS temp5,(adr_DIAGRAMM_SPALTE_L)	; X2L
	LDS temp6,(adr_DIAGRAMM_SPALTE_H)	; X2H
	LDS temp,(adr_DIAGRAMM_Y_WERT_C)	
	rcall DIAGRAMM_Y_WERT_AUFBEREITEN_TEMP	; Y-wert aufbereiten (0...200)	
	mov temp7,temp						; Y2L
	clr temp8							; Y2H
	; Linie zeichnen				
	rcall GRAFIC_LINIE_TEMP1_8
	; OLD speichern	(fr nchste Linie)
	LDS temp,(adr_DIAGRAMM_Y_WERT_C)	
	STS (adr_DIAGRAMM_Y_WERT_C_OLD),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DIAGRAMM_ZEICHNEN_KURVE_D:
	rcall GRAFIC_PUNKTGROESSE_1			; Punktgre	
	ldi temp1,(FARBE_KURVE_D)			; Farbe			
	rcall GRAFIC_FARBE_TEMP1
	; X-SPALTE laden				
	LDS temp1,(adr_DIAGRAMM_SPALTE_L)	; X1L
	LDS temp2,(adr_DIAGRAMM_SPALTE_H)	; X1H
	; erster Datenpunkt	?			
	tst temp1
	brne DIAGRAMM_ZEICHNEN_KURVE_D_LINIE
	tst temp2
	brne DIAGRAMM_ZEICHNEN_KURVE_D_LINIE
	; ja, erster Datenpunkt			
	LDS temp,(adr_DIAGRAMM_Y_WERT_D)
	STS (adr_DIAGRAMM_Y_WERT_D_OLD),temp
	rjmp DIAGRAMM_ZEICHNEN_KURVE_D_LINIE_w
DIAGRAMM_ZEICHNEN_KURVE_D_LINIE:
	; X-Spalte Minus 1	(fr LINIE)			
	sub temp1,EINS						; X1L
	sbc temp2,NULL						; X1H
DIAGRAMM_ZEICHNEN_KURVE_D_LINIE_W:
	LDS temp,(adr_DIAGRAMM_Y_WERT_D_OLD)
	rcall DIAGRAMM_Y_WERT_AUFBEREITEN_TEMP	; Y-wert aufbereiten (0...200)	
	mov temp3,temp						; Y1L
	clr temp4							; Y1H
	LDS temp5,(adr_DIAGRAMM_SPALTE_L)	; X2L
	LDS temp6,(adr_DIAGRAMM_SPALTE_H)	; X2H
	LDS temp,(adr_DIAGRAMM_Y_WERT_D)	
	rcall DIAGRAMM_Y_WERT_AUFBEREITEN_TEMP	; Y-wert aufbereiten (0...200)	
	mov temp7,temp						; Y2L
	clr temp8							; Y2H
	; Linie zeichnen				
	rcall GRAFIC_LINIE_TEMP1_8
	; OLD speichern	(fr nchste Linie)
	LDS temp,(adr_DIAGRAMM_Y_WERT_D)	
	STS (adr_DIAGRAMM_Y_WERT_D_OLD),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DIAGRAMM_AKTUELLE_SPALTE_CLEAR:
	; SCHWARZ			
	rcall GRAFIC_PUNKTGROESSE_1				; Punktgre	
	rcall GRAFIC_FARBE_SCHWARZ				; FARBE			
	LDS temp1,(adr_DIAGRAMM_SPALTE_L)		; X1L
	LDS temp2,(adr_DIAGRAMM_SPALTE_H)		; X1H
	ldi temp3,(240-20-1)					; Y1L
	ldi temp4,0								; Y1H
	mov temp5,temp1							; X2L
	mov temp6,temp2							; X2H
	ldi temp7,(240-20-200-1)				; Y2L
	ldi temp8,0								; Y2H
	rcall GRAFIC_LINIE_TEMP1_8
;-------------------------------------------------------------------------------
	ldi temp1,(FARBE_RASTER)				; Farbe			
	rcall GRAFIC_FARBE_TEMP1
	; Spalte laden	
	LDS temp1,(adr_DIAGRAMM_SPALTE_L)		; X1L
	LDS temp2,(adr_DIAGRAMM_SPALTE_H)		; X1H
DIAGRAMM_AKTUELLE_SPALTE_CLEAR_Y:
	; ist NULL ?	
	tst temp2
	brne DIAGRAMM_AKTUELLE_SPALTE_CLEAR_NO_NULL
	tst temp1
	brne DIAGRAMM_AKTUELLE_SPALTE_CLEAR_NO_NULL
	; ist NULL		
	rjmp DIAGRAMM_AKTUELLE_SPALTE_CLEAR_Y_RUN
DIAGRAMM_AKTUELLE_SPALTE_CLEAR_NO_NULL:
	; -32			
	subi temp1,LOW (32)
	sbci temp2,HIGH(32)
	tst temp2
	; wenn positiv, dann Schleife	
	brpl DIAGRAMM_AKTUELLE_SPALTE_CLEAR_Y
	rjmp DIAGRAMM_AKTUELLE_SPALTE_CLEAR_Y_FERTIG
DIAGRAMM_AKTUELLE_SPALTE_CLEAR_Y_RUN:
	; Y-RASTER		
	LDS temp1,(adr_DIAGRAMM_SPALTE_L)		; X1L
	LDS temp2,(adr_DIAGRAMM_SPALTE_H)		; X1H
	rcall DIAGRAMM_Y_RASTER_ZEICHNEN_TEMP1_2
DIAGRAMM_AKTUELLE_SPALTE_CLEAR_Y_FERTIG:
;-------------------------------------------------------------------------------
	; X-RASTER	
	LDS temp1,(adr_DIAGRAMM_SPALTE_L)		; X1L
	LDS temp2,(adr_DIAGRAMM_SPALTE_H)		; X1H
	ldi temp3,220-1
	ldi temp4,0
	; Schleife	
	ldi temp9,11
DIAGRAMM_AKTUELLE_SPALTE_CLEAR_w:
	rcall GRAFIC_PUNKT_TEMP1_4
	subi temp3,20
	dec temp9
	brne DIAGRAMM_AKTUELLE_SPALTE_CLEAR_w
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DIAGRAMM_RASTER_ZEICHEN:
	rcall GRAFIC_CLEAR						; CLEAR			
	rcall GRAFIC_PUNKTGROESSE_1				; Punktgre	
	ldi temp1,(FARBE_RASTER)				; Farbe			
	rcall GRAFIC_FARBE_TEMP1
	; X-RASTER								
	; Schleife								
	ldi temp9,11
	ldi temp1,0
DIAGRAMM_RASTER_ZEICHEN_S1:
	rcall DIAGRAMM_X_RASTER_ZEICHNEN_TEMP1
	subi temp1,-20
	dec temp9
	brne DIAGRAMM_RASTER_ZEICHEN_S1
;-------------------------------------------------------------------------------
	; Y-RASTER								
	; Schleife								
	ldi temp9,10
	clr temp1
	clr temp2
DIAGRAMM_RASTER_ZEICHEN_S2:
	rcall DIAGRAMM_Y_RASTER_ZEICHNEN_TEMP1_2
	subi temp1, LOW (-32)	
	sbci temp2, HIGH(-32)
	dec temp9
	brne DIAGRAMM_RASTER_ZEICHEN_S2
	; PAKET senden	
	rcall PAKET_SENDEN
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Display 320x240																
; Horizontale Linie Zeichen														
; temp1 = X-Wert																
DIAGRAMM_X_RASTER_ZEICHNEN_TEMP1:
	push temp1
	; Y-Wert Aufbereiten		
	mov temp,temp1
	rcall DIAGRAMM_Y_WERT_AUFBEREITEN_TEMP
	ldi temp1,0							; X1L
	ldi temp2,0 						; X1H
	mov temp3,temp						; Y1L
	ldi temp4,0							; Y1H
	ldi temp5,Byte1(320-1)				; X2L
	ldi temp6,Byte2(320-1)				; X2H
	mov temp7,temp3						; Y2L
	ldi temp8,0							; Y2H
	rcall GRAFIC_LINIE_TEMP1_8
	pop temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Display 320x240																
; Vertikale Linie Zeichen														
DIAGRAMM_Y_RASTER_ZEICHNEN_TEMP1_2:
	;ldi temp1,0							; X1L
	;ldi temp2,0 							; X1H
	ldi temp3,(240-20-1)					; Y1L
	ldi temp4,0								; Y1H
	mov temp5,temp1							; X2L
	mov temp6,temp2							; X2H
	ldi temp7,(240-20-200-1)				; Y2L
	ldi temp8,0								; Y2H
	rcall GRAFIC_LINIE_TEMP1_8
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DIAGRAMM_LAUS_ZEICHNEN:
	rcall GRAFIC_PUNKTGROESSE_5			; Punktgre	
	ldi temp1,(FARBE_LAUS)				; Farbe			
	rcall GRAFIC_FARBE_TEMP1

	LDS temp1,(adr_DIAGRAMM_SPALTE_L) 	; X1	
	LDS temp2,(adr_DIAGRAMM_SPALTE_H)	; X1	
	ldi temp3,223						; YL	
	clr temp4							; YH	
	rcall GRAFIC_PUNKT_TEMP1_4			; Punkt	

	rcall GRAFIC_FARBE_SCHWARZ			; FARBE	
	LDS temp1,(adr_DIAGRAMM_SPALTE_L) 	; X1	
	LDS temp2,(adr_DIAGRAMM_SPALTE_H)	; X1	
	sub temp1,EINS
	sbc temp2,NULL
	ldi temp3,223						; YL	
	clr temp4							; YH	
	rcall GRAFIC_PUNKT_TEMP1_4			; Punkt	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 0...319																		
DIAGRAMM_SPALTE_PLUS_EINS:
	; DIAGRAMM_SPALTE
	LDS temp1,(adr_DIAGRAMM_SPALTE_L)
	LDS temp2,(adr_DIAGRAMM_SPALTE_H)
	add temp1,EINS
	adc temp2,NULL
	; BERLAUF (HIGH-BYTE)
	cpi temp2,HIGH(319)
	tst temp2
	breq DIAGRAMM_SPALTE_PLUS_EINS_FERTIG
DIAGRAMM_SPALTE_PLUS_EINS_w:
	; berlauf (LOW-BYTE)
	cpi temp1,LOW (319+1)
	brlo DIAGRAMM_SPALTE_PLUS_EINS_FERTIG
DIAGRAMM_SPALTE_PLUS_EINS_UEBERLAUF:
	clr temp1
	clr temp2
DIAGRAMM_SPALTE_PLUS_EINS_FERTIG:
	STS(adr_DIAGRAMM_SPALTE_L),temp1
	STS(adr_DIAGRAMM_SPALTE_H),temp2

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 0...240																		
DIAGRAMM_Y_WERT_AUFBEREITEN_TEMP:
	push temp1
	cpi temp,200
	brlo DIAGRAMM_Y_WERT_AUFBEREITEN_TEMP1_w
	breq DIAGRAMM_Y_WERT_AUFBEREITEN_TEMP1_w
	; begrenzen					
	ldi temp,200
DIAGRAMM_Y_WERT_AUFBEREITEN_TEMP1_w:
	; 239 Minus temp			
	ldi temp1,(240-1)
	sub temp1,temp
	mov temp,temp1
	; Minus OFFSET				
	ldi temp1,(20)
	sub temp,temp1
	; KOPIE						
	pop temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DIAGRAMM_OFFSET_AUTO:
	STS(adr_FREQUENZ_BYTE0),NULL
	STS(adr_FREQUENZ_BYTE1),NULL
	STS(adr_FREQUENZ_BYTE2),NULL
	STS(adr_FREQUENZ_BYTE3),NULL
	rcall SPI_DDS_FREQUENZ_EINSTELLEN
	rcall wait_1s
	; MESSEN (log)			
	rcall MESSEN_0_TEMP1_2_SRAM
	; etwas nach oben verschieben	
	subi temp1, LOW (20)	
	sbci temp2, HIGH(20)
	STS(adr_DIAGRAMM_Y_OFFSET_BYTE0),temp1
	STS(adr_DIAGRAMM_Y_OFFSET_BYTE1),temp2
	STS(adr_DIAGRAMM_Y_OFFSET_BYTE2),NULL
	STS(adr_DIAGRAMM_Y_OFFSET_BYTE3),NULL

	rcall MENUE_01_HAUPTMENUE
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
