; #############################################################################
; #############################################################################
; #############################################################################
;Der Touchbereich mit dem Return-Code (Code=0: alle) wird aus der Abfrage entfernt.
;Mit n1=0 bleibt der Bereich am Display sichtbar, mit n1=1 wird der Bereich gelscht.
TASTEN_CLEAR:
	rcall GRAFIC_ESC_27	; ESC senden	
	ldi temp,'A'	; A			
	rcall PAKET_DATA_TEMP
	ldi temp,'L'	; L			
	rcall PAKET_DATA_TEMP
	ldi temp,0		; 0			
	rcall PAKET_DATA_TEMP
	ldi temp,1		; 1			
	rcall PAKET_DATA_TEMP
	rcall PAKET_SENDEN
ret
; #############################################################################
; #############################################################################
; #############################################################################
TASTE_GEDRUECKT_CARRY:
	; Tasten abfragen	
	rcall TASTEN_ABFRAGEN
	LDS temp,(adr_TASTE)
	tst temp
	breq TASTE_GEDRUECKT_NO
TASTE_GEDRUECKT_YES:
	SEC ; SET Carry		
	ret
TASTE_GEDRUECKT_NO:
	CLC ; CLEAR CARRY	
ret
; #############################################################################
; #############################################################################
; #############################################################################
TASTEN_ABFRAGEN:
	; BUS-CHECK						
	rcall TWI_BUS_FREE_CHECK
	; NULL							
	STS(adr_TASTE),NULL
	; INHALT_SENDEPUFFER_ANFORDERN	
	rcall PAKET_INHALT_SENDEPUFFER_ANFORDERN_TEMP1_SRAM4
	; Daten vorhanden ?				
	tst temp1
	breq TASTEN_ABFRAGEN_FERTIG
;------------------------------------------------------------------------------
	; Tasteninformation auslesen	
	LDS temp,(adr_GRAFIC_PUFFER_256+0)
	cpi temp,27	; ESC	
	brne TASTEN_ABFRAGEN_FERTIG
	LDS temp,(adr_GRAFIC_PUFFER_256+1)
	cpi temp,'A'; "A"	
	brne TASTEN_ABFRAGEN_FERTIG
	LDS temp,(adr_GRAFIC_PUFFER_256+2)
	cpi temp,1	; 1		
	brne TASTEN_ABFRAGEN_FERTIG
	LDS temp,(adr_GRAFIC_PUFFER_256+3)
	STS(adr_TASTE),temp
TASTEN_ABFRAGEN_FERTIG:
;------------------------------------------------------------------------------
	; Taste gedrckt ?		
	LDS temp,(adr_TASTE)
	tst temp
	brne TASTEN_AUSWERTEN
	ret
TASTEN_AUSWERTEN:
	; Taste wurde gedrckt	
	cpi temp,100
	; > 100 kein clear		
	brsh TASTEN_AUSWERTEN_NO_CLEAR
	rcall GRAFIC_CLEAR
TASTEN_AUSWERTEN_NO_CLEAR:
	; Z-initialisieren		
	ldi ZL, LOW(TASTEN_AUSWERTEN_SPRUNGMARKE)
	ldi ZH,HIGH(TASTEN_AUSWERTEN_SPRUNGMARKE)
	LDS temp,(adr_TASTE)
	add ZL,temp
	adc ZH,NULL
	ijmp	; Sprung nach Z	

TASTEN_AUSWERTEN_SPRUNGMARKE:
	ret							; 00
	rjmp MENUE_01_HAUPTMENUE	; 01
	ret
	ret
	ret
	rjmp ANZEIGE_STATUS
	rjmp ANZEIGE_DISPLAY_INFORMATIONEN
	rjmp NEUSTART_MIT_WDR	
	ret
	ret
	rjmp MENUE_10_SYSTEM		; 10
	ret
	ret
	rjmp MENUE_13_HELLIGKEIT_EINGABE_START
	ret 
	ret
	rjmp MENUE_16_FREQUENZ_EINGABE_START
	ret
	rjmp MENUE_18_FREQUENZ_START_EINGABE_START
	rjmp MENUE_19_FREQUENZ_STOPP_EINGABE_START
	ret 	; 20
	ret 
	rjmp MENUE_22_SKALE_EINGABE_START
	rjmp MENUE_23_TURBOSCHWELLE_EINGABE_START
	rjmp MENUE_24_OFFSET_EINGABE_START
	rjmp DIAGRAMM_OFFSET_AUTO
	ret
	ret
	ret
	ret
	ret ; 30
	ret
	ret
	ret
	ret
	ret
	ret
	ret
	ret
	ret
	ret	; 40
	ret
	ret
	ret
	ret
	ret
	ret
	ret
	ret
	ret
	ret	; 50
	ret
	ret
	ret
	ret
	ret
	ret
	ret
	ret
	ret
	rjmp DIAGRAMM_SCAN	; 60
	ret
	rjmp DIAGRAMM_ZF_1
	ret
	rjmp DIAGRAMM_ZF_2
	ret
	rjmp DIAGRAMM_ZF_3
	ret
	ret
	ret
	ret	; 70
	ret
	ret
	ret
	ret
	ret
	ret
	ret
	ret
	ret
	ret	; 80
	ret
	ret
	ret
	ret
	ret
	ret
	ret
	ret
	ret
	ret	; 90
	ret
	ret
	ret
	ret
	ret
	ret
	ret
	ret
	ret
	rjmp TASTEN_DEFINIEREN_ZAHLEN	; 100	
	rjmp MENUE_100_EINGABE_ZAHLEN_C	; Zahl-1
	rjmp MENUE_100_EINGABE_ZAHLEN_C	; Zahl-2
	rjmp MENUE_100_EINGABE_ZAHLEN_C	; Zahl-3
	rjmp MENUE_100_EINGABE_ZAHLEN_C	; Zahl-4
	rjmp MENUE_100_EINGABE_ZAHLEN_C	; Zahl-5
	rjmp MENUE_100_EINGABE_ZAHLEN_C	; Zahl-6
	rjmp MENUE_100_EINGABE_ZAHLEN_C	; Zahl-7
	rjmp MENUE_100_EINGABE_ZAHLEN_C	; Zahl-8
	rjmp MENUE_100_EINGABE_ZAHLEN_C	; Zahl-9
	rjmp MENUE_100_EINGABE_ZAHLEN_C	; Zahl-0(110)
	rjmp MENUE_100_EINGABE_ZAHLEN_C	; "OK"	
	rjmp MENUE_100_EINGABE_ZAHLEN_C	; "ESC"	
	rjmp MENUE_100_EINGABE_ZAHLEN_C	; "Back"	
	ret
	ret
	ret
	ret
	ret
	ret
	ret	; 120
ret
; #############################################################################
; #############################################################################
; #############################################################################
TASTE_DEFINIEREN_SONDERTASTE:
	; Sondertaste (kleine Taste unten rechts)
	ldi ZL,  low(TASTE_01_SONDERTASTE*2)	; TASTE
	ldi ZH, high(TASTE_01_SONDERTASTE*2)
	rcall TASTE_DEFINIEREN_Z
ret
; #############################################################################
; #############################################################################
; #############################################################################
TASTEN_DEFINIEREN_ZAHLEN:
	rcall GRAFIC_CLEAR
	rcall ANZEIGE_EINGABE_ZAHL_KURZ

	; ZAHLEN		
	ldi ZL,  low(TASTE_101_ZAHL_1*2)	; TASTE 1
	ldi ZH, high(TASTE_101_ZAHL_1*2)
	rcall TASTE_DEFINIEREN_Z
	ldi ZL,  low(TASTE_102_ZAHL_2*2)	; TASTE 2
	ldi ZH, high(TASTE_102_ZAHL_2*2)
	rcall TASTE_DEFINIEREN_Z
	ldi ZL,  low(TASTE_103_ZAHL_3*2)	; TASTE 3
	ldi ZH, high(TASTE_103_ZAHL_3*2)
	rcall TASTE_DEFINIEREN_Z

	ldi ZL,  low(TASTE_104_ZAHL_4*2)	; TASTE 4
	ldi ZH, high(TASTE_104_ZAHL_4*2)
	rcall TASTE_DEFINIEREN_Z
	ldi ZL,  low(TASTE_105_ZAHL_5*2)	; TASTE 5
	ldi ZH, high(TASTE_105_ZAHL_5*2)
	rcall TASTE_DEFINIEREN_Z
	ldi ZL,  low(TASTE_106_ZAHL_6*2)	; TASTE 6
	ldi ZH, high(TASTE_106_ZAHL_6*2)
	rcall TASTE_DEFINIEREN_Z

	ldi ZL,  low(TASTE_107_ZAHL_7*2)	; TASTE 7
	ldi ZH, high(TASTE_107_ZAHL_7*2)
	rcall TASTE_DEFINIEREN_Z
	ldi ZL,  low(TASTE_108_ZAHL_8*2)	; TASTE 8
	ldi ZH, high(TASTE_108_ZAHL_8*2)
	rcall TASTE_DEFINIEREN_Z
	ldi ZL,  low(TASTE_109_ZAHL_9*2)	; TASTE 9
	ldi ZH, high(TASTE_109_ZAHL_9*2)
	rcall TASTE_DEFINIEREN_Z

	ldi ZL,  low(TASTE_110_ZAHL_0*2)	; TASTE 0
	ldi ZH, high(TASTE_110_ZAHL_0*2)
	rcall TASTE_DEFINIEREN_Z

	ldi ZL,  low(TASTE_111_ZAHL_OK*2)			; TASTE "OK"
	ldi ZH, high(TASTE_111_ZAHL_OK*2)
	rcall TASTE_DEFINIEREN_Z

	ldi ZL,  low(TASTE_112_ZAHL_ESC*2)			; TASTE "ESC"
	ldi ZH, high(TASTE_112_ZAHL_ESC*2)
	rcall TASTE_DEFINIEREN_Z

	ldi ZL,  low(TASTE_113_ZAHL_BACK*2)			; TASTE "ESC"
	ldi ZH, high(TASTE_113_ZAHL_BACK*2)
	rcall TASTE_DEFINIEREN_Z


ret
; #############################################################################
; #############################################################################
; #############################################################################
; Eine TASTE definieren															
;																				
;	INP: Z (TABELLE)															
;																				
TASTE_DEFINIEREN_Z:
	rcall GRAFIC_ESC_27	; ESC senden
	ldi temp, 'A'	; "A"			
	rcall PAKET_DATA_TEMP
	ldi temp, 'T'	; "T" oder "K"	
	rcall PAKET_DATA_TEMP
;-------------------------------------------
	LPM temp, Z+  	;(LOW)	X1	
	mov XL,temp		
	rcall PAKET_DATA_TEMP
	LPM temp, Z+  	;(HIGH)
	mov XH,temp
	rcall PAKET_DATA_TEMP
;-------------------------------------------
	LPM temp, Z+  	;(LOW)	Y1	
	mov YL,temp
	rcall PAKET_DATA_TEMP
	LPM temp, Z+  	;(HIGH)
	mov YH,temp
	rcall PAKET_DATA_TEMP
;-------------------------------------------
	LPM temp1, Z+  	;(LOW)	X2	
	LPM temp2, Z+  	;(HIGH)
	add XL,temp1
	adc XH,temp2
	mov temp,XL
	rcall PAKET_DATA_TEMP
	mov temp,XH
	rcall PAKET_DATA_TEMP
;-------------------------------------------
	LPM temp1, Z+  	;(LOW)	Y2	
	LPM temp2, Z+  	;(HIGH)
	add YL,temp1
	adc YH,temp2
	mov temp,YL
	rcall PAKET_DATA_TEMP
	mov temp,YH
	rcall PAKET_DATA_TEMP
;-------------------------------------------
	LPM temp, Z+  	;(LOW)	WERT gedrckt	
	rcall PAKET_DATA_TEMP
	LPM temp, Z+  	;(HIGH) DUMMY	
	ldi temp,0		; WERT beim loslassen
	rcall PAKET_DATA_TEMP
;-------------------------------------------
	; SCHLEIFE			
TASTE_DEFINIEREN_Z_SCHLEIFE:
	LPM temp, Z+  	;(LOW)	TEXT			
	cpi temp,27
	breq TASTE_DEFINIEREN_Z_FERTIG
	rcall PAKET_DATA_TEMP
	LPM temp, Z+  	;DUMMY	
	rjmp TASTE_DEFINIEREN_Z_SCHLEIFE
;-------------------------------------------
TASTE_DEFINIEREN_Z_FERTIG:
	ldi temp,0
	rcall PAKET_DATA_TEMP
	rcall PAKET_SENDEN
ret
; #############################################################################
; #############################################################################
; #############################################################################
